/**
 * Copyright 2012 Web Cohesion.
 * 
 * Some custom license text.
 * 
 *
 * Generated by <a href="http://enunciate.codehaus.org">Enunciate</a>.
 */
package org.codehaus.enunciate.samples.genealogy.jaxws_client.services;

/**
 *  The source service is used to access and store source information about genealogical information.
 *  Compared to the person service, this one is much more customized.
 * 
 *  @author Ryan Heaton
 */
 @javax.jws.WebService (
   name = "source-service",
   targetNamespace = "http://enunciate.codehaus.org/samples/full"
 )
 @javax.xml.bind.annotation.XmlSeeAlso ( {
  org.codehaus.enunciate.samples.genealogy.jaxws_client.exceptions.EisFault.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.UnknownSourceBean.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddEvents.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddEventsResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddInfoSet.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddInfoSetResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddSource.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.DeletePerson.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.DeletePersonResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetRelationships.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetRelationshipsResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetSource.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetSourceResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadAssertions.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadAssertionsResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadExtPerson.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadExtPersonResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadPersons.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ReadPersonsResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.RelationshipExceptionBean.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.ServiceExceptionBean.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.StoreGenericProperties.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.StoreGenericPropertiesResponse.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.Touch.class,
  org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.TouchResponse.class
 } )
public interface SourceService {

  /**
   *  Adds a source to the database.  Example of a one-way method.
   * 
   *  @param source The source to add to the database.
   */
  @javax.jws.WebMethod (
    operationName = "addSource",
    action = ""
  )
  @javax.jws.WebResult (
    name = "return",
    targetNamespace = "",
    header = false,
    partName = "return"
  )
  @javax.xml.ws.RequestWrapper (
    localName = "addSource",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddSource"
  )
  @javax.jws.soap.SOAPBinding (
    style = javax.jws.soap.SOAPBinding.Style.DOCUMENT,
    use = javax.jws.soap.SOAPBinding.Use.LITERAL,
    parameterStyle = javax.jws.soap.SOAPBinding.ParameterStyle.WRAPPED
  )
  @javax.jws.Oneway
  void addSource(@javax.jws.WebParam( name = "source", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "source" ) org.codehaus.enunciate.samples.genealogy.jaxws_client.cite.Source source) ;

  /**
   *  Reads a source from the database.
   * 
   *  @param id The id of the source to read from the database.
   *  @return The source.
   *  @throws ServiceException If a source couldn't be read from the database.
   *  @throws UnknownSourceException If no source by that id was found in the database.
   */
  @javax.jws.WebMethod (
    operationName = "getSource",
    action = ""
  )
  @javax.jws.WebResult (
    name = "return",
    targetNamespace = "",
    header = false,
    partName = "return"
  )
  @javax.xml.ws.RequestWrapper (
    localName = "getSource",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetSource"
  )
  @javax.xml.ws.ResponseWrapper (
    localName = "getSourceResponse",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.GetSourceResponse"
  )
  @javax.jws.soap.SOAPBinding (
    style = javax.jws.soap.SOAPBinding.Style.DOCUMENT,
    use = javax.jws.soap.SOAPBinding.Use.LITERAL,
    parameterStyle = javax.jws.soap.SOAPBinding.ParameterStyle.WRAPPED
  )
  org.codehaus.enunciate.samples.genealogy.jaxws_client.cite.Source getSource(@javax.jws.WebParam( name = "id", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "id" ) java.lang.String id) throws org.codehaus.enunciate.samples.genealogy.jaxws_client.services.ServiceException, org.codehaus.enunciate.samples.genealogy.jaxws_client.services.UnknownSourceException;

  /**
   *  Adds an infoset to a specified source.
   * 
   *  @param sourceId The id of the source to which to add the infoset.
   *  @param infoSet The infoset to add to the source.
   *  @return The id of the infoset that was added.
   *  @throws ServiceException If the infoset couldn't be added to the source.
   */
  @javax.jws.WebMethod (
    operationName = "addInfoSet",
    action = ""
  )
  @javax.jws.WebResult (
    name = "myweirdresultname",
    targetNamespace = "",
    header = false,
    partName = "return"
  )
  @javax.xml.ws.RequestWrapper (
    localName = "addInfoSet",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddInfoSet"
  )
  @javax.xml.ws.ResponseWrapper (
    localName = "addInfoSetResponse",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddInfoSetResponse"
  )
  @javax.jws.soap.SOAPBinding (
    style = javax.jws.soap.SOAPBinding.Style.DOCUMENT,
    use = javax.jws.soap.SOAPBinding.Use.LITERAL,
    parameterStyle = javax.jws.soap.SOAPBinding.ParameterStyle.WRAPPED
  )
  java.lang.String addInfoSet(@javax.jws.WebParam( name = "sourceId", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "sourceId" ) java.lang.String sourceId, @javax.jws.WebParam( name = "infoSet", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "infoSet" ) org.codehaus.enunciate.samples.genealogy.jaxws_client.cite.InfoSet infoSet) throws org.codehaus.enunciate.samples.genealogy.jaxws_client.services.ServiceException;

  /**
   *  Adds a bunch of events to an infoset.
   * 
   *  @param infoSetId The id of the infoset to which to add the events.
   *  @param assertions The events that are to be added to the infoset.
   *  @param contributorId The if of the contributor adding the events to the infoset.
   *  @return Some message.
   *  @throws ServiceException If the events couldn't be added to the infoset.
   */
  @javax.jws.WebMethod (
    operationName = "addEvents",
    action = ""
  )
  @javax.jws.WebResult (
    name = "resultOfAddingEvents",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    header = true,
    partName = "return"
  )
  @javax.xml.ws.RequestWrapper (
    localName = "addEvents",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddEvents"
  )
  @javax.xml.ws.ResponseWrapper (
    localName = "addEventsResponse",
    targetNamespace = "http://enunciate.codehaus.org/samples/full",
    className = "org.codehaus.enunciate.samples.genealogy.jaxws_client.services.jaxws.AddEventsResponse"
  )
  @javax.jws.soap.SOAPBinding (
    style = javax.jws.soap.SOAPBinding.Style.DOCUMENT,
    use = javax.jws.soap.SOAPBinding.Use.LITERAL,
    parameterStyle = javax.jws.soap.SOAPBinding.ParameterStyle.WRAPPED
  )
  java.lang.String addEvents(@javax.jws.WebParam( name = "infoSetId", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "infoSetId" ) java.lang.String infoSetId, @javax.jws.WebParam( name = "assertions", targetNamespace="", mode = javax.jws.WebParam.Mode.IN , header = false, partName = "assertions" ) org.codehaus.enunciate.samples.genealogy.jaxws_client.data.Event[] assertions, @javax.jws.WebParam( name = "contributorId", targetNamespace="http://enunciate.codehaus.org/samples/full", mode = javax.jws.WebParam.Mode.IN , header = true, partName = "contributorId" ) java.lang.String contributorId) throws org.codehaus.enunciate.samples.genealogy.jaxws_client.services.ServiceException;

}
